## lomiri-docviewer-app 3.0.1+git20230127.ab13dca+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(lomiri-docviewer-app VERSION 3.0.1 LANGUAGES CXX)

set(MANIFEST_PATH "click/manifest.json.in" CACHE INTERNAL "Relative path to the manifest file")
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")
set(CMAKE_AUTOMOC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-permissive -pedantic -Wall -Wextra -fPIC")

# Debugging purpose. Keep commented unless you need it.
# set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_DEBUG}")

include(FindPkgConfig)
include(GNUInstallDirs)

option(INSTALL_TESTS    "Install the tests on make install" on)
option(CLICK_MODE       "Installs to a contained location" on)
option(NO_CACHE         "Disable caching of click dependencies (CLICK_MODE only)" off)

set(DEFAULT_ROOT "/opt/click.ubuntu.com" CACHE PATH "Default click package root path")
set(LIBREOFFICE_INCLUDE_DIR "" CACHE PATH "Custom LibreOfficeKit include directory")

set(APP_NAME            lomiri-docviewer-app)
set(DESKTOP_FILE        "${PROJECT_NAME}.desktop")
set(ICON_FILE           docviewer-app.png)
set(SPLASH_FILE         docviewer-app-splash.svg)
set(AUTOPILOT_DIR       lomiri_docviewer_app)

# Find out the architecture for package building
# to determine the plugin's installation path
execute_process(
  COMMAND dpkg-architecture -qDEB_HOST_MULTIARCH
  OUTPUT_VARIABLE ARCH_TRIPLET
  OUTPUT_STRIP_TRAILING_WHITESPACE
)
execute_process(
  COMMAND dpkg-architecture -qDEB_HOST_ARCH
  OUTPUT_VARIABLE CLICK_ARCH
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

if(NOT CLICK_MODE)
    install(FILES lomiri-docviewer-app.1 DESTINATION "${MANDIR}/man1")
endif(NOT CLICK_MODE)

include(Click)

# Tests
enable_testing()

add_subdirectory(po)
add_subdirectory(click)
add_subdirectory(data)
add_subdirectory(src)
add_subdirectory(tests)

=== po/CMakeLists.txt ===
include(FindGettext)
if(NOT GETTEXT_FOUND)
  message(FATAL_ERROR "Could not find gettext")
endif(NOT GETTEXT_FOUND)
find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)

set(DOMAIN ${PROJECT_NAME})
set(POT_FILE ${DOMAIN}.pot)

file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/LINGUAS LINGUAS
     REGEX "^[^#].*")
string(REGEX MATCHALL "[^ \t]+" LANGS "${LINGUAS}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/POTFILES.in
               ${CMAKE_CURRENT_BINARY_DIR}/POTFILES COPYONLY
)

# Creates the .pot file containing the translations template
add_custom_target(${POT_FILE} ALL
                  COMMENT "Generating translation template"
                  # Extract the translatable messages from the desktop file
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          --from-code=UTF-8
                          --language=Desktop
                          --package-name='${GETTEXT_PACKAGE}'
                          --copyright-holder='Canonical Ltd.'
                          -D ${CMAKE_BINARY_DIR}/data
                          ${DESKTOP_FILE}.in
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          --from-code=UTF-8
                          --c++ --qt --add-comments=TRANSLATORS
                          --keyword=tr --keyword=tr:1,2 --keyword=N_ --keyword=_
                          --package-name='${PROJECT_NAME}'
                          --copyright-holder='Canonical Ltd.'
                          -D ${CMAKE_SOURCE_DIR}
                          -D ${CMAKE_CURRENT_SOURCE_DIR}
                          -D ${CMAKE_CURRENT_BINARY_DIR}
                          --join-existing
                          --files-from=${CMAKE_CURRENT_BINARY_DIR}/POTFILES)

foreach(LANG ${LANGS})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${LANG}.po
                   ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.po
                   COPYONLY)
endforeach(LANG)
gettext_process_pot_file(${POT_FILE} ALL
                         INSTALL_DESTINATION ${CMAKE_INSTALL_LOCALEDIR}
                         LANGUAGES ${LANGS})

# make the translation files visible on qtcreator
file(GLOB TRANSLATION_FILES
     RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
     *.po *.pot)

add_custom_target(docviewer_ubports_translation_files ALL SOURCES ${TRANSLATION_FILES})

=== debian/changelog ===
lomiri-docviewer-app (3.0.1+git20230127.ab13dca+dfsg-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1030026).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 30 Jan 2023 15:31:03 +0100

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none,  repacksuffix=+dfsg, dversionmangle=s/\+dfsg//, pretty=3.0.1+git%cd.%h" \
https://gitlab.com/ubports/development/apps/lomiri-docviewer-app \
HEAD debian uupdate

## lomiri-docviewer-app 3.0.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-docviewer-app VERSION 3.0.1 LANGUAGES CXX)
+project(lomiri-docviewer-app VERSION 3.0.2 LANGUAGES CXX)
 
 set(MANIFEST_PATH "click/manifest.json.in" CACHE INTERNAL "Relative path to the manifest file")
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")
@@ -25,21 +25,23 @@
 set(SPLASH_FILE         docviewer-app-splash.svg)
 set(AUTOPILOT_DIR       lomiri_docviewer_app)
 
+if(CLICK_MODE)
 # Find out the architecture for package building
 # to determine the plugin's installation path
-execute_process(
-  COMMAND dpkg-architecture -qDEB_HOST_MULTIARCH
-  OUTPUT_VARIABLE ARCH_TRIPLET
-  OUTPUT_STRIP_TRAILING_WHITESPACE
-)
-execute_process(
-  COMMAND dpkg-architecture -qDEB_HOST_ARCH
-  OUTPUT_VARIABLE CLICK_ARCH
-  OUTPUT_STRIP_TRAILING_WHITESPACE
-)
+    execute_process(
+      COMMAND dpkg-architecture -qDEB_HOST_MULTIARCH
+      OUTPUT_VARIABLE ARCH_TRIPLET
+      OUTPUT_STRIP_TRAILING_WHITESPACE
+    )
+    execute_process(
+      COMMAND dpkg-architecture -qDEB_HOST_ARCH
+      OUTPUT_VARIABLE CLICK_ARCH
+      OUTPUT_STRIP_TRAILING_WHITESPACE
+    )
+endif(CLICK_MODE)
 
 if(NOT CLICK_MODE)
-    install(FILES lomiri-docviewer-app.1 DESTINATION "${MANDIR}/man1")
+    install(FILES lomiri-docviewer-app.1 DESTINATION "${CMAKE_INSTALL_FULL_MANDIR}/man1")
 endif(NOT CLICK_MODE)
 
 include(Click)

=== src/app/CMakeLists.txt ===
file(GLOB_RECURSE QML_SRCS *.qml *.js)

find_package(Qt5Core)
find_package(Qt5Gui)
find_package(Qt5Qml)
find_package(Qt5Quick)

add_definitions(
  -DGETTEXT_PACKAGE=\"${PROJECT_NAME}\"
  -DGETTEXT_LOCALEDIR=\"${CMAKE_INSTALL_LOCALEDIR}\"
)

string(REGEX REPLACE "^/*(.+)/*$" "\\1" CLICK_REL_PATH "${DEFAULT_ROOT}")

configure_file(
    config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/config.h
    @ONLY
)

include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
)

set(docviewer_SRCS
    main.cpp
    renderengine.cpp
    rendertask.cpp
    ${QML_SRCS}
)

add_executable(lomiri-docviewer-app ${docviewer_SRCS})
set_property(TARGET lomiri-docviewer-app PROPERTY ENABLE_EXPORTS True)

qt5_use_modules(lomiri-docviewer-app Gui Qml Quick)
target_link_libraries(lomiri-docviewer-app stdc++)

if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
add_custom_target(docviewer-qmlfiles ALL
    COMMAND cp -r ${CMAKE_CURRENT_SOURCE_DIR}/qml ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${QMLFILES}
)
endif(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")

install(DIRECTORY qml DESTINATION ${DATA_DIR})

if(CLICK_MODE)
  install(TARGETS lomiri-docviewer-app DESTINATION ${BIN_DIR})
else()
  install(TARGETS lomiri-docviewer-app RUNTIME DESTINATION bin)
endif()

=== debian/changelog ===
lomiri-docviewer-app (3.0.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/watch:
    + Start watching upstream releases.
  * debian/patches:
     + Drop patches 1001, 1002, 1003 and 2000. All applied upstream.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 04 Feb 2023 21:13:39 +0100

## lomiri-docviewer-app 3.0.3+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-docviewer-app VERSION 3.0.2 LANGUAGES CXX)
+project(lomiri-docviewer-app VERSION 3.0.3 LANGUAGES CXX)
 
 set(MANIFEST_PATH "click/manifest.json.in" CACHE INTERNAL "Relative path to the manifest file")
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")

=== data/CMakeLists.txt ===
if(CLICK_MODE)
  set(ICON ${ICON_FILE})
  set(SPLASH ${SPLASH_FILE})
  set(DESKTOP_DIR ${DATA_DIR})

  install(FILES ${ICON_FILE} DESTINATION ${DATA_DIR})
  install(FILES ${SPLASH_FILE} DESTINATION ${DATA_DIR})
else(CLICK_MODE)
  set(ICON "${CMAKE_INSTALL_PREFIX}/${DATA_DIR}/${ICON_FILE}")
  set(DESKTOP_DIR ${CMAKE_INSTALL_DATADIR}/applications)

  install(DIRECTORY icons/hicolor DESTINATION ${CMAKE_INSTALL_DATADIR}/icons
    FILES_MATCHING PATTERN *.png
  )
endif(CLICK_MODE)

set(EXEC "${APP_NAME}")

configure_file(${DESKTOP_FILE}.in.in ${DESKTOP_FILE}.in @ONLY)

configure_file(${DESKTOP_FILE}.in.in ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}.in)
add_custom_target(${DESKTOP_FILE} ALL
    COMMENT "Merging translations into ${DESKTOP_FILE}"
    COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
            --desktop --template=${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}.in
            -o ${DESKTOP_FILE}
            -d ${CMAKE_SOURCE_DIR}/po
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}
  DESTINATION ${DESKTOP_DIR}
)

=== debian/changelog ===
lomiri-docviewer-app (3.0.3+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Translation updates.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 27 Feb 2023 14:57:09 +0100

=== debian/control ===
Source: lomiri-docviewer-app
Section: misc
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>,
           Marius Gripsgard <marius@ubports.com>,
Build-Depends: cmake,
               debhelper-compat (=13),
               libpoppler-qt5-dev,
               libreofficekit-dev,
               pkg-config,
               python3-all,
               qtbase5-dev (>= 5.4.0),
               qtchooser,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               qml-module-qtquick2,
               qtdeclarative5-private-dev,
               qtbase5-private-dev,
               qml-module-qttest,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/apps/lomiri-docviewer-app
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-docviewer-app/
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-docviewer-app.git

Package: lomiri-docviewer-app
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         suru-icon-theme (>= 14.04+15.10.20150707-0ubuntu1),
         qml-module-qtquick2,
         qml-module-lomiri-components,
         qml-module-lomiri-layouts,
         qml-module-lomiri-content,
         qml-module-qtquick-layouts,
         qml-module-qtquick-window2,
         libreoffice-vanilla (>= 5.0.0) | libreoffice (>= 5.0.0),
Description: Document Viewer App for Lomiri Operating Environment
 This app is a core app for Ubuntu Touch's shell Lomiri. Ubuntu Touch is
 a mobile OS developed by the UBports Foundation. Lomiri is its operating
 environment optimized for touch based human-machine interaction, but
 also supports convergence (i.e. switching between tablet/phone and
 desktop mode).
 .
 This package provides Lomiri's Document Viewer App.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_configure:
	dh_auto_configure -- -DCLICK_MODE=OFF

override_dh_install:
	dh_install

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
opts="repacksuffix=+dfsg, dversionmangle=s/\+dfsg//" \
https://gitlab.com/ubports/development/apps/lomiri-docviewer-app/tags .*/lomiri-docviewer-app-v(\d\S+)\.tar\.gz

## lomiri-docviewer-app 3.0.4%2Bdfsg

=== src/app/CMakeLists.txt ===
--- 
+++ 
@@ -49,3 +49,5 @@
 else()
   install(TARGETS lomiri-docviewer-app RUNTIME DESTINATION bin)
 endif()
+
+install(PROGRAMS lomiri-docviewer-app-migrate.py DESTINATION ${DATA_DIR})

=== src/plugin/CMakeLists.txt ===
add_subdirectory(file-qml-plugin)
add_subdirectory(poppler-qml-plugin)
add_subdirectory(libreofficetoolkit-qml-plugin)

=== debian/changelog ===
lomiri-docviewer-app (3.0.4+dfsg-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:56:09 +1100

lomiri-docviewer-app (3.0.4+dfsg-2build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 05:44:24 +0000

lomiri-docviewer-app (3.0.4+dfsg-2) unstable; urgency=medium

  * debian/patches:
    + Add patch files 0001, 0002 and 0003. Fix missing desktop icon and missing
      splash screen.
  * debian/control:
    + Switch from pkg-config to pkgconf. Thanks, lintian.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 26 Feb 2024 10:09:01 +0100

lomiri-docviewer-app (3.0.4+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update copyright attribution for debian/.
    + Update copyright attributions.
  * debian/rules:
    + Don'ship lomiri-docviewer-app-migrate.py in Debian.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 02 Feb 2024 23:37:07 +0100

## lomiri-docviewer-app 3.0.4+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-docviewer-app VERSION 3.0.3 LANGUAGES CXX)
+project(lomiri-docviewer-app VERSION 3.0.4 LANGUAGES CXX)
 
 set(MANIFEST_PATH "click/manifest.json.in" CACHE INTERNAL "Relative path to the manifest file")
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")

=== click/CMakeLists.txt ===
if(CLICK_MODE)
  configure_file(manifest.json.in ${CMAKE_CURRENT_BINARY_DIR}/manifest.json @ONLY)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/manifest.json DESTINATION ${CMAKE_INSTALL_PREFIX})
  install(FILES docviewer.apparmor docviewer-content.json lomiri-docviewer-app.url-dispatcher DESTINATION ${CMAKE_INSTALL_PREFIX})
endif(CLICK_MODE)


# Make the click files visible in Qt Creator
file(GLOB CLICK_FILES
  RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
  *.json *.json.in *.apparmor
)

add_custom_target(docviewer_ubports_CLICKFiles ALL SOURCES ${CLICK_FILES})

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -2,19 +2,21 @@
   set(ICON ${ICON_FILE})
   set(SPLASH ${SPLASH_FILE})
   set(DESKTOP_DIR ${DATA_DIR})
+  set(EXEC "lomiri-docviewer-app-migrate.py ${APP_NAME}")
 
   install(FILES ${ICON_FILE} DESTINATION ${DATA_DIR})
   install(FILES ${SPLASH_FILE} DESTINATION ${DATA_DIR})
 else(CLICK_MODE)
   set(ICON "${CMAKE_INSTALL_PREFIX}/${DATA_DIR}/${ICON_FILE}")
   set(DESKTOP_DIR ${CMAKE_INSTALL_DATADIR}/applications)
+  set(EXEC "${APP_NAME}")
 
   install(DIRECTORY icons/hicolor DESTINATION ${CMAKE_INSTALL_DATADIR}/icons
     FILES_MATCHING PATTERN *.png
   )
 endif(CLICK_MODE)
 
-set(EXEC "${APP_NAME}")
+set(TRYEXEC "${APP_NAME}")
 
 configure_file(${DESKTOP_FILE}.in.in ${DESKTOP_FILE}.in @ONLY)

=== src/CMakeLists.txt ===
add_subdirectory(app)
add_subdirectory(plugin)

=== src/plugin/file-qml-plugin/CMakeLists.txt ===
set(PLUGIN_DIR DocumentViewer)
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

find_package(Qt5Core)
find_package(Qt5Qml)
find_package(Qt5Quick)

#add the sources to compile
set(fileqmlplugin_SRCS
    backend.cpp
    documentmodel.cpp
    fswatcher.cpp
    docviewerfile.cpp
    docviewerutils.cpp
)

add_library(fileqmlplugin MODULE
    ${fileqmlplugin_SRCS}
)

qt5_use_modules(fileqmlplugin Qml Quick)

# Copy the plugin, the qmldir file and other assets to the build dir for running in QtCreator
if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
    add_custom_command(TARGET fileqmlplugin POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
        COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/qmldir ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
        COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:fileqmlplugin> ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
    )
endif(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")

# Install plugin file
install(TARGETS fileqmlplugin DESTINATION ${QT_IMPORTS_DIR}/${PLUGIN_DIR})
install(FILES qmldir DESTINATION ${QT_IMPORTS_DIR}/${PLUGIN_DIR})

=== src/plugin/libreofficetoolkit-qml-plugin/CMakeLists.txt ===
set(PLUGIN_DIR DocumentViewer/LibreOffice)

find_package(Qt5Core)
find_package(Qt5Gui)
find_package(Qt5Qml)
find_package(Qt5Quick)

file(GLOB_RECURSE QML_SRCS
    qml/*.qml
    qml/*.js
)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${LIBREOFFICE_INCLUDE_DIR}
)

#add the sources to compile
set(libreofficetoolkitqmlplugin_SRCS
    plugin.cpp
    lodocument.cpp
    loview.cpp
    sgtileitem.cpp
    lopartsimageprovider.cpp
    lopartsimageresponse.cpp
    lopartsmodel.cpp
    lorendertask.cpp
    lcunits.cpp
    lozoom.cpp
    ${QML_SRCS}
)

#add the headers to compile
set(libreofficetoolkitqmlplugin_HDRS
    twips.h
    config.h
    loerror.h
)

add_library(libreofficetoolkitqmlplugin MODULE
    ${libreofficetoolkitqmlplugin_SRCS}
    ${libreofficetoolkitqmlplugin_HDRS}
)

#target_link_libraries(libreofficetoolkitqmlplugin dl)
qt5_use_modules(libreofficetoolkitqmlplugin Gui Qml Quick)

# Copy the plugin, the qmldir file and other assets to the build dir for running in QtCreator
if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
add_custom_command(TARGET libreofficetoolkitqmlplugin POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/qmldir ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
    COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:libreofficetoolkitqmlplugin> ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
    COMMAND ${CMAKE_COMMAND} -E copy ${QML_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
)
endif(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")

# Install plugin file
install(TARGETS libreofficetoolkitqmlplugin DESTINATION ${QT_IMPORTS_DIR}/${PLUGIN_DIR})
install(FILES qmldir DESTINATION ${QT_IMPORTS_DIR}/${PLUGIN_DIR})
install(FILES ${QML_SRCS} DESTINATION ${QT_IMPORTS_DIR}/${PLUGIN_DIR})

=== src/plugin/poppler-qml-plugin/CMakeLists.txt ===
set(PLUGIN_DIR DocumentViewer/PDF)

find_package(Qt5Core)
find_package(Qt5Gui)
find_package(Qt5Qml)
find_package(Qt5Quick)
find_package(Qt5Xml)
find_package(Qt5Concurrent)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
)

file(GLOB_RECURSE QML_SRCS
    qml/*.qml
    qml/*.js
)


#add the sources to compile
set(popplerqmlplugin_SRCS
    plugin.cpp
    pdfdocument.cpp
    verticalview.cpp
    pdftocmodel.cpp
    pdfrendertask.cpp
    sgtileitem.cpp
    pagedecoration.cpp
    pageoverlay.cpp
    pdfzoom.cpp
    lcunits.cpp
    touchdetectionarea.cpp
    ${QML_SRCS}
)

set(popplerqmlplugin_HDRS
    pdferror.h
    twips.h
    config.h
)

add_library(popplerqmlplugin MODULE
    ${popplerqmlplugin_SRCS}
    ${popplerqmlplugin_HDRS}
)

target_link_libraries(popplerqmlplugin poppler-qt5)

qt5_use_modules(popplerqmlplugin Gui Qml Quick Xml Concurrent)

# Copy the plugin, the qmldir file and other assets to the build dir for running in QtCreator
if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
add_custom_command(TARGET popplerqmlplugin POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/qmldir ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
    COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:popplerqmlplugin> ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
    COMMAND ${CMAKE_COMMAND} -E copy ${QML_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
)
endif(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")

# Install plugin file
install(TARGETS popplerqmlplugin DESTINATION ${QT_IMPORTS_DIR}/${PLUGIN_DIR})
install(FILES qmldir DESTINATION ${QT_IMPORTS_DIR}/${PLUGIN_DIR})
install(FILES ${QML_SRCS} DESTINATION ${QT_IMPORTS_DIR}/${PLUGIN_DIR})

=== debian/changelog ===
lomiri-docviewer-app (3.0.4+dfsg-3) unstable; urgency=medium

  [ Mike Gabriel ]
  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.

  [ Guido Berhoerster ]
  * debian/patches:
    + Add patch 0004 from upstream in order to fix i18n.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 30 Apr 2024 12:28:28 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                debhelper-compat (=13),
                libpoppler-qt5-dev,
                libreofficekit-dev,
-               pkg-config,
+               pkgconf,
                python3-all,
                qtbase5-dev (>= 5.4.0),
                qtchooser,

## lomiri-docviewer-app 3.1.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-docviewer-app VERSION 3.0.4 LANGUAGES CXX)
+project(lomiri-docviewer-app VERSION 3.1.0 LANGUAGES CXX)
 
 set(MANIFEST_PATH "click/manifest.json.in" CACHE INTERNAL "Relative path to the manifest file")
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")
@@ -16,12 +16,11 @@
 option(CLICK_MODE       "Installs to a contained location" on)
 option(NO_CACHE         "Disable caching of click dependencies (CLICK_MODE only)" off)
 
-set(DEFAULT_ROOT "/opt/click.ubuntu.com" CACHE PATH "Default click package root path")
 set(LIBREOFFICE_INCLUDE_DIR "" CACHE PATH "Custom LibreOfficeKit include directory")
 
 set(APP_NAME            lomiri-docviewer-app)
 set(DESKTOP_FILE        "${PROJECT_NAME}.desktop")
-set(ICON_FILE           docviewer-app.png)
+set(ICON_FILE           docviewer-app.svg)
 set(SPLASH_FILE         docviewer-app-splash.svg)
 set(AUTOPILOT_DIR       lomiri_docviewer_app)
 
@@ -46,11 +45,20 @@
 
 include(Click)
 
+find_package(Qt5Core REQUIRED)
+find_package(Qt5Concurrent REQUIRED)
+find_package(Qt5Gui REQUIRED)
+find_package(Qt5Qml REQUIRED)
+find_package(Qt5Quick REQUIRED)
+find_package(Qt5Xml REQUIRED)
+
 # Tests
-enable_testing()
+include(CTest)
 
 add_subdirectory(po)
 add_subdirectory(click)
 add_subdirectory(data)
 add_subdirectory(src)
-add_subdirectory(tests)
+if(BUILD_TESTING)
+    add_subdirectory(tests)
+endif()

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -7,13 +7,13 @@
   install(FILES ${ICON_FILE} DESTINATION ${DATA_DIR})
   install(FILES ${SPLASH_FILE} DESTINATION ${DATA_DIR})
 else(CLICK_MODE)
-  set(ICON "${CMAKE_INSTALL_PREFIX}/${DATA_DIR}/${ICON_FILE}")
+  set(ICON "${DATA_DIR}/${ICON_FILE}")
+  set(SPLASH "${DATA_DIR}/${SPLASH_FILE}")
   set(DESKTOP_DIR ${CMAKE_INSTALL_DATADIR}/applications)
   set(EXEC "${APP_NAME}")
 
-  install(DIRECTORY icons/hicolor DESTINATION ${CMAKE_INSTALL_DATADIR}/icons
-    FILES_MATCHING PATTERN *.png
-  )
+  install(FILES ${ICON_FILE} DESTINATION ${DATA_DIR})
+  install(FILES ${SPLASH_FILE} DESTINATION ${DATA_DIR})
 endif(CLICK_MODE)
 
 set(TRYEXEC "${APP_NAME}")

=== src/plugin/libreofficetoolkit-qml-plugin/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,4 @@
 set(PLUGIN_DIR DocumentViewer/LibreOffice)
-
-find_package(Qt5Core)
-find_package(Qt5Gui)
-find_package(Qt5Qml)
-find_package(Qt5Quick)
 
 file(GLOB_RECURSE QML_SRCS
     qml/*.qml
@@ -44,7 +39,11 @@
 )
 
 #target_link_libraries(libreofficetoolkitqmlplugin dl)
-qt5_use_modules(libreofficetoolkitqmlplugin Gui Qml Quick)
+target_link_libraries(libreofficetoolkitqmlplugin
+    Qt5::Gui
+    Qt5::Qml
+    Qt5::Quick
+)
 
 # Copy the plugin, the qmldir file and other assets to the build dir for running in QtCreator
 if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")

=== debian/changelog ===
lomiri-docviewer-app (3.1.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards-Version to 4.7.0. No changes needed.
  * debian/patches:
    + Drop patches 0001, 0002, 0003, and 0004. All applied upstream.
    + Drop 2001_no-unit-tests.patch. Tests can be disabled via CMake option now.
  * debian/rules:
    + Disable unit tests.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 11 Sep 2024 21:25:23 +0200

=== debian/rules ===
--- 
+++ 
@@ -13,10 +13,12 @@
 	dh_missing --fail-missing
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCLICK_MODE=OFF
+	dh_auto_configure -- -DCLICK_MODE=OFF -DBUILD_TESTING=OFF
 
 override_dh_install:
 	dh_install
+	# not needed in Debian, Ubuntu Touch specific script
+	rm debian/lomiri-docviewer-app/usr/share/lomiri-docviewer-app/lomiri-docviewer-app-migrate.py
 
 get-orig-source:
 	uscan --noconf --force-download --rename --download-current-version --destdir=..

## lomiri-docviewer-app 3.1.1%2Bdfsg

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -7,12 +7,12 @@
   install(FILES ${ICON_FILE} DESTINATION ${DATA_DIR})
   install(FILES ${SPLASH_FILE} DESTINATION ${DATA_DIR})
 else(CLICK_MODE)
-  set(ICON "${DATA_DIR}/${ICON_FILE}")
+  set(ICON "${APP_NAME}")
   set(SPLASH "${DATA_DIR}/${SPLASH_FILE}")
   set(DESKTOP_DIR ${CMAKE_INSTALL_DATADIR}/applications)
   set(EXEC "${APP_NAME}")
 
-  install(FILES ${ICON_FILE} DESTINATION ${DATA_DIR})
+  install(FILES ${ICON_FILE} DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps" RENAME "${ICON}.svg")
   install(FILES ${SPLASH_FILE} DESTINATION ${DATA_DIR})
 endif(CLICK_MODE)

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
                qtdeclarative5-private-dev,
                qtbase5-private-dev,
                qml-module-qttest,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/apps/lomiri-docviewer-app
 Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-docviewer-app/

## lomiri-docviewer-app 3.1.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-docviewer-app VERSION 3.1.0 LANGUAGES CXX)
+project(lomiri-docviewer-app VERSION 3.1.1 LANGUAGES CXX)
 
 set(MANIFEST_PATH "click/manifest.json.in" CACHE INTERNAL "Relative path to the manifest file")
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")
@@ -16,6 +16,7 @@
 option(CLICK_MODE       "Installs to a contained location" on)
 option(NO_CACHE         "Disable caching of click dependencies (CLICK_MODE only)" off)
 
+set(LIBREOFFICE_PREFIX "/usr" CACHE PATH "LibreOffice prefix (which contains 'lib/libreoffice/program')")
 set(LIBREOFFICE_INCLUDE_DIR "" CACHE PATH "Custom LibreOfficeKit include directory")
 
 set(APP_NAME            lomiri-docviewer-app)

=== click/CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,9 @@
   configure_file(manifest.json.in ${CMAKE_CURRENT_BINARY_DIR}/manifest.json @ONLY)
   install(FILES ${CMAKE_CURRENT_BINARY_DIR}/manifest.json DESTINATION ${CMAKE_INSTALL_PREFIX})
   install(FILES docviewer.apparmor docviewer-content.json lomiri-docviewer-app.url-dispatcher DESTINATION ${CMAKE_INSTALL_PREFIX})
+else(CLICK_MODE)
+  install(FILES docviewer-content.json DESTINATION ${CMAKE_INSTALL_DATADIR}/lomiri-content-hub/peers RENAME lomiri-docviewer-app)
+  install(FILES lomiri-docviewer-app.url-dispatcher DESTINATION ${CMAKE_INSTALL_DATADIR}/lomiri-url-dispatcher/urls)
 endif(CLICK_MODE)

=== src/app/CMakeLists.txt ===
file(GLOB_RECURSE QML_SRCS *.qml *.js)

add_definitions(
  -DGETTEXT_PACKAGE=\"${PROJECT_NAME}\"
  -DGETTEXT_LOCALEDIR=\"${CMAKE_INSTALL_FULL_LOCALEDIR}\"
)

configure_file(
    config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/config.h
    @ONLY
)

include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
)

set(docviewer_SRCS
    main.cpp
    renderengine.cpp
    rendertask.cpp
    ${QML_SRCS}
)

add_executable(lomiri-docviewer-app ${docviewer_SRCS})
set_property(TARGET lomiri-docviewer-app PROPERTY ENABLE_EXPORTS True)

target_link_libraries(lomiri-docviewer-app
    stdc++
    Qt5::Gui
    Qt5::Qml
    Qt5::Quick
)

if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
add_custom_target(docviewer-qmlfiles ALL
    COMMAND cp -r ${CMAKE_CURRENT_SOURCE_DIR}/qml ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${QMLFILES}
)
endif(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")

install(DIRECTORY qml DESTINATION ${DATA_DIR})

if(CLICK_MODE)
  install(TARGETS lomiri-docviewer-app DESTINATION ${BIN_DIR})
else()
  install(TARGETS lomiri-docviewer-app RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

install(PROGRAMS lomiri-docviewer-app-migrate.py DESTINATION ${DATA_DIR})

=== src/plugin/file-qml-plugin/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,5 @@
 set(PLUGIN_DIR DocumentViewer)
 include_directories(${CMAKE_CURRENT_SOURCE_DIR})
-
-find_package(Qt5Core)
-find_package(Qt5Qml)
-find_package(Qt5Quick)
 
 #add the sources to compile
 set(fileqmlplugin_SRCS
@@ -18,7 +14,10 @@
     ${fileqmlplugin_SRCS}
 )
 
-qt5_use_modules(fileqmlplugin Qml Quick)
+target_link_libraries(fileqmlplugin
+    Qt5::Qml
+    Qt5::Quick
+)
 
 # Copy the plugin, the qmldir file and other assets to the build dir for running in QtCreator
 if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")

=== src/plugin/libreofficetoolkit-qml-plugin/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,12 @@
 file(GLOB_RECURSE QML_SRCS
     qml/*.qml
     qml/*.js
+)
+
+configure_file(
+    config.h.in
+    ${CMAKE_CURRENT_BINARY_DIR}/config.h
+    @ONLY
 )
 
 include_directories(
@@ -29,8 +35,8 @@
 #add the headers to compile
 set(libreofficetoolkitqmlplugin_HDRS
     twips.h
-    config.h
     loerror.h
+    ${CMAKE_CURRENT_BINARY_DIR}/config.h
 )
 
 add_library(libreofficetoolkitqmlplugin MODULE

=== src/plugin/poppler-qml-plugin/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,4 @@
 set(PLUGIN_DIR DocumentViewer/PDF)
-
-find_package(Qt5Core)
-find_package(Qt5Gui)
-find_package(Qt5Qml)
-find_package(Qt5Quick)
-find_package(Qt5Xml)
-find_package(Qt5Concurrent)
 
 include_directories(
     ${CMAKE_CURRENT_SOURCE_DIR}
@@ -45,9 +38,14 @@
     ${popplerqmlplugin_HDRS}
 )
 
-target_link_libraries(popplerqmlplugin poppler-qt5)
-
-qt5_use_modules(popplerqmlplugin Gui Qml Quick Xml Concurrent)
+target_link_libraries(popplerqmlplugin
+    Qt5::Concurrent
+    Qt5::Gui
+    Qt5::Qml
+    Qt5::Quick
+    Qt5::Xml
+    poppler-qt5
+)
 
 # Copy the plugin, the qmldir file and other assets to the build dir for running in QtCreator
 if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")

=== debian/changelog ===
lomiri-docviewer-app (3.1.1+dfsg-4) unstable; urgency=medium

  * debian/patches:
    + Add 2001_hide-app-if-not-in-lomiri.patch.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 05 May 2025 16:41:23 +0200

lomiri-docviewer-app (3.1.1+dfsg-3) unstable; urgency=medium

  * debian/control:
    + Revert: Exclude architectures hurd-any (FTBFS, not supported) and
      mip64el (missing libreoffice dependency).
    + Add to B-D: libreoffice. Also adding libreoffice to B-D assures
      that libreoffice is available for the target architecture we build
      for. If it is unavailable, buildd.debian.org will react with
      BD-Uninstallable rather than Britney blocking unstable -> testing
      migration due to the missing libreoffice runtime dependency.
      .
      This remedies failing lomiri-docviewer-app testing migration due to
      libreoffice missing for some rare architecture (mips64el
      currently). (Closes: #1102111).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 05 Apr 2025 14:40:55 +0200

lomiri-docviewer-app (3.1.1+dfsg-2) REJECTED; urgency=medium

  * debian/control:
    + Exclude architectures hurd-any (FTBFS, not supported) and mip64el
      (missing libreoffice dependency). (Closes: #1102111).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 05 Apr 2025 11:02:54 +0200

lomiri-docviewer-app (3.1.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 03 Mar 2025 08:19:24 +0100

=== debian/control ===
--- 
+++ 
@@ -18,6 +18,14 @@
                qtdeclarative5-private-dev,
                qtbase5-private-dev,
                qml-module-qttest,
+# Also adding libreoffice to B-D to assure that libreoffice is available for the
+# target architecture we build for. If it is unavailable, buildd.debian.org will
+# react with BD-Uninstallable rather than Britney blocking unstable -> testing
+# migration due to the missing libreoffice runtime dependency.
+#
+# This remedies failing lomiri-docviewer-app testing migration due to libreoffice
+# missing for some rare architecture (mips64el currently).
+               libreoffice,
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/apps/lomiri-docviewer-app
